summaryrefslogtreecommitdiff
path: root/plugins/bgnotify
diff options
context:
space:
mode:
authorTim O'Brien <timo@t413.com>2014-11-06 10:34:26 -0800
committerTim O'Brien <timo@t413.com>2014-11-06 10:34:26 -0800
commite16d3e45d30fbf981f503b4d078d84c71a070a1d (patch)
tree95d0c70c54f214d2d572285b48224e8f7668e504 /plugins/bgnotify
parent7034b01cd10cebb2658f54aa07ac0ce5ee64e0e0 (diff)
downloadzsh-e16d3e45d30fbf981f503b4d078d84c71a070a1d.tar.gz
zsh-e16d3e45d30fbf981f503b4d078d84c71a070a1d.tar.bz2
zsh-e16d3e45d30fbf981f503b4d078d84c71a070a1d.zip
Add bgnotify plugin, a cross-platform background notifier!
Diffstat (limited to 'plugins/bgnotify')
-rw-r--r--plugins/bgnotify/README.md39
-rwxr-xr-xplugins/bgnotify/bgnotify.plugin.zsh65
2 files changed, 104 insertions, 0 deletions
diff --git a/plugins/bgnotify/README.md b/plugins/bgnotify/README.md
new file mode 100644
index 000000000..bf4b1fd09
--- /dev/null
+++ b/plugins/bgnotify/README.md
@@ -0,0 +1,39 @@
+# bgnotify zsh plugin
+
+cross-platform background notifications for long running commands! Supports OSX and Ubuntu linux.
+
+Standalone homepage: [t413/zsh-background-notify](https://github.com/t413/zsh-background-notify)
+
+----------------------------------
+
+## How to use!
+
+Just add bgnotify to your plugins list in your `.zshrc`
+
+- On OS X you'll need [terminal-notifer](https://github.com/alloy/terminal-notifier)
+ * `brew install terminal-notifier` (or `gem install terminal-notifier`)
+- On ubuntu you're already all set!
+
+
+## Configuration
+
+One can configure a few things:
+
+- `bgnotify_threshold` sets the notification threshold time (default 6 seconds)
+- `function bgnotify_formatted` lets you change the notification
+
+Use these by adding a function definition before the your call to source. Example:
+
+~~~ sh
+bgnotify_threshold=4 ## set your own notification threshold
+
+function bgnotify_formatted {
+ ## $1=exit_status, $2=command, $3=elapsed_time
+ [ $1 -eq 0 ] && title="Holy Smokes Batman!" || title="Holy Graf Zeppelin!"
+ bgnotify "$title -- after $3 s" "$2";
+}
+
+plugins=(git bgnotify) ## add to plugins list
+source $ZSH/oh-my-zsh.sh ## existing source call
+~~~
+
diff --git a/plugins/bgnotify/bgnotify.plugin.zsh b/plugins/bgnotify/bgnotify.plugin.zsh
new file mode 100755
index 000000000..f204d9dc8
--- /dev/null
+++ b/plugins/bgnotify/bgnotify.plugin.zsh
@@ -0,0 +1,65 @@
+#!/usr/bin/env zsh
+
+
+## setup ##
+
+[[ -o interactive ]] || return #interactive only!
+zmodload zsh/datetime || { print "can't load zsh/datetime"; return } # faster than date()
+autoload -Uz add-zsh-hook || { print "can't add zsh hook!"; return }
+
+(( ${+bgnotify_threshold} )) || bgnotify_threshold=5 #default 10 seconds
+
+
+## definitions ##
+
+if ! (type notify_formatted | grep -q 'function'); then
+ echo "using default notify_formatted"
+ function bgnotify_formatted {
+ ## exit_status, command, elapsed_time
+ [ $1 -eq 0 ] && title="#win (took $3 s)" || title="#fail (took $3 s)"
+ bgnotify "$title" "$2"
+ }
+fi
+
+currentWindowId () {
+ if hash notify-send 2>/dev/null; then #ubuntu!
+ xprop -root | awk '/NET_ACTIVE_WINDOW/ { print $5; exit }'
+ elif hash osascript 2>/dev/null; then #osx
+ osascript -e 'tell application (path to frontmost application as text) to id of front window' 2&> /dev/null
+ fi
+}
+
+bgnotify () {
+ if hash notify-send 2>/dev/null; then #ubuntu!
+ notify-send $1 $2
+ elif hash terminal-notifier 2>/dev/null; then #osx
+ terminal-notifier -message $2 -title $1
+ elif hash growlnotify 2>/dev/null; then #osx growl
+ growlnotify -m $1 $2
+ fi
+}
+
+
+## Zsh hooks ##
+
+bgnotify_begin() {
+ bgnotify_timestamp=$EPOCHSECONDS
+ bgnotify_lastcmd=$1
+ bgnotify_windowid=$(currentWindowId)
+}
+
+bgnotify_end() {
+ didexit=$?
+ elapsed=$(( $EPOCHSECONDS - $bgnotify_timestamp ))
+ past_threshold=$(( $elapsed >= $bgnotify_threshold ))
+ if (( bgnotify_timestamp > 0 )) && (( past_threshold )); then
+ if [ $(currentWindowId) != "$bgnotify_windowid" ]; then
+ print -n "\a"
+ bgnotify_formatted "$didexit" "$bgnotify_lastcmd" "$elapsed"
+ fi
+ fi
+ bgnotify_timestamp=0 #reset it to 0!
+}
+
+add-zsh-hook preexec bgnotify_begin
+add-zsh-hook precmd bgnotify_end